<?php 
// initialize
require 'twitteroauth/autoload.php';
use Abraham\TwitterOAuth\TwitterOAuth;

// configure
$consumerKey = '<consumerKey>';
$consumerSecret = '<consumerSecret>';
$accessToken = '<accessToken>';
$accessTokenSecret = '<accessTokenSecret>';

$db_host = '<db_host>';
$db_user = '<db_user>';
$db_pass = '<db_pass>';
$db_name = '<db_name>';

$intHowFreshMinute = 2;

//$reply_tweet = 'もしかして寝坊しましたか?相手が納得出来る遅刻の言い訳を作るAndroidアプリは http://curious4dev.mydns.jp/ewake/redirect.php?tid=';
$reply_tweet = array('寝坊を検知しました。遅刻の言い訳を提案します。','もしかして寝坊しましたか?勝手に遅刻の言い訳を考えました!');
$sql_select_fresh = 'select count(1) as count from ewakeLog where date_add(reply_date, interval 3 hour) > now() and user_id = :user_id;';
$sql_select_user = 'select count(1) as count from ewakeLog where user_id = :user_id;';
$sql_insert_ok = 'insert into ewakeLog (tweet_id, user_id, user_name, tweet, reply, tweet_date, reply_date, user_follower, user_follow, user_favourites, user_tweets, source) values(:tweet_id, :user_id, :user_name, :tweet, :reply, :tweet_date, now(), :user_follower, :user_follow, :user_favourites, :user_tweets, :source);';
$sql_insert_ng = 'insert into ewakeLog (tweet_id, user_id, user_name, tweet,        tweet_date,             user_follower, user_follow, user_favourites, user_tweets, source) values(:tweet_id, :user_id, :user_name, :tweet,         :tweet_date,        :user_follower, :user_follow, :user_favourites, :user_tweets, :source);';

// load file
$ewake_text = file('ewake.txt');

// conenct to mysql
$pdo = new PDO("mysql:dbname=" . $db_name, $db_user, $db_pass, array(PDO::MYSQL_ATTR_INIT_COMMAND => "SET CHARACTER SET `utf8`"));

// create Twitter object and search from tweets
$twObj = new TwitterOAuth($consumerKey, $consumerSecret, $accessToken, $accessTokenSecret);
$search_key = "寝坊した";
$options = array('q' => $search_key, 'count' => '100', 'lang' => 'ja');
$json = $twObj->get('search/tweets', $options);

// check tweets
foreach ($json->statuses as $result) {
    // get parameters from tweet
    $tweet_id = $result->id_str;
    $user_id = $result->user->id_str;
    $tweet = $result->text;
    $user_name = $result->user->screen_name;
    $created_at = $result->created_at;
	// add column 2015.03.10
	$user_follower = $result->user->followers_count;
	$user_follow = $result->user->friends_count;
	$user_favourites = $result->user->favourites_count;
	$user_tweets = $result->user->statuses_count;
    $source = $result->source;

    // delete \n
    $tweet = str_replace("\r\n", '', $tweet);
    $tweet = str_replace("\n", '', $tweet);

    // is Reply?
    if (mb_substr_count($tweet, '@') > 0 ) {
        $isReply = true;
    } else {
        $isReply = false;
    }

    // is RT?
    if (strpos($tweet, "RT") == false) {
        $isRT = false;
    } else {
        $isRT = true;
    }

    // is Android?
    if (strpos($source, "android") == false) {
        $isAndroid = false;
    } else {
        $isAndroid = true;
    }

    // is overslept?
    if (mb_strpos($tweet, $search_key) ==false) {
        $isNebou = false;
    } else {
        $isNebou = true;
    }

    // with HashTag?
    if (strpos($tweet, "#") == false) {
        $isHashTag = false;
    } else {
        $isHashTag = true;
    }

    // is Fresh Tweet?(less than 2 minute)
    $now = strtotime("-" . $intHowFreshMinute . " min");
    $check = strtotime($created_at);
    if($now <= $check) {
        $isFresh = true;
    } else {
        $isFresh = false;
    }

    // check already send user last 2 hour
    $statement = $pdo->prepare($sql_select_fresh);
    $statement->bindValue(':user_id', $user_id, PDO::PARAM_INT);
    $statement->execute();
    $count = 0;
    if ($row = $statement->fetch()) $count = $row['count'];
    if ($count == 0) {
        $isAlreadySend = false;
    } else {
        $isAlreadySend = true;
    }

    // check user count
    $statement = $pdo->prepare($sql_select_user);
    $statement->bindValue(':user_id', $user_id, PDO::PARAM_INT);
    $statement->execute();
    $count = 0;
    if ($row = $statement->fetch()) $count = $row['count'];
    if ($count == 0) {
        $sufix = "";
    } elseif($count == 1) {
        $sufix = "今回で" . $count+1 . "度目の提案となります。";
	} elseif($count > 1) {
        $sufix = "今回で" . $count+1 . "度目の提案となります。多すぎる傾向にあります。";
    }

    // send reply when not reply and not RT and not send
    if ($isReply == false && $isRT == false && $isAlreadySend == false && $isHashTag == false && $isFresh == true && $isNebou == true ) {
        // send reply
        $tmp_text = $ewake_text[mt_rand(0,count($ewake_text)-1)];
        $tmp_text = str_replace("\r",'',$tmp_text);
        $tmp_text = str_replace("\n",'',$tmp_text);
        $tmp_text = str_replace("\r\n",'',$tmp_text);
        $ewake = $reply_tweet[mt_rand(0,1)] . '「' . $tmp_text .'」' . $sufix;
        $reply = '@' . $user_name. ' '. $ewake;
        $reply_json = $twObj -> post('statuses/update', ['status'=>$reply, 'in_reply_to_status_id'=>$tweet_id]);
        $created_at = date('Y-m-d H:i:s', strtotime($created_at));

        if(isset($reply_json->id) == true) {
        // insert to log when success
          $statement = $pdo->prepare($sql_insert_ok);
          $statement->bindParam(':reply', $reply, PDO::PARAM_STR);
          $statement->bindParam(':tweet', $tweet, PDO::PARAM_STR);
        } else {
          $statement = $pdo->prepare($sql_insert_ng);
          $statement->bindParam(':tweet', $tweet, PDO::PARAM_STR);
        }
        $statement->bindParam(':tweet_id', $tweet_id, PDO::PARAM_STR);
        $statement->bindParam(':tweet_date', $created_at, PDO::PARAM_STR);
        $statement->bindParam(':user_id', $user_id, PDO::PARAM_STR);
        $statement->bindParam(':user_name', $user_name, PDO::PARAM_STR);
        $statement->bindParam(':user_follower', $user_follower, PDO::PARAM_INT);
        $statement->bindParam(':user_follow', $user_follow, PDO::PARAM_INT);
        $statement->bindParam(':user_favourites', $user_favourites, PDO::PARAM_INT);
        $statement->bindParam(':user_tweets', $user_tweets, PDO::PARAM_INT);
        $statement->bindParam(':source', $source, PDO::PARAM_STR);
        $statement->execute();

    }
}
?>
